\section{Related work}

Epidemic protocols were introduced in 1988 by Xerox researchers on
replicated databases %  They defined two epidemic processes:
% anti-entropy and rumor mongering
\cite{demers_epidemic_1988}. % As
% anti-entropy is costly when exchanged states are big, requires
% application level merging and has mutating messages incompatible with
% network coding, only rumor mongering is viable for an application
% independant RLNC dissemination protocol.
They introduced three
protocols to exchange rumors: push, pull and push pull.

\paragraph{Push protocols} to transmit rumors, push-based protocols
imply that informed nodes relay the message to their neighbors.  Some
protocols are active, as they have a background thread that regularly
retransmits received rumors, like balls and
bins~\cite{koldehofe_simple_2004}.  Other protocols adopt a reactive
approach, where rumors are directly forwarded to the node's neighbors
upon reception, like infect-and-die and infect-forever
protocols~\cite{euster_epidemics_2004}.
%These protocols need a stopping condition to prevent flooding the network forever, which can be a limitation of hopes or forwarding only rumors that were not received before.\df{Not sure if we need this part   about active passive as we do not do anything that depends on this   in the paper}
Push protocols are particularly efficient to quickly reach most of the
network, however reaching all the nodes takes more time and involves
significant redundancy, and thus bandwidth consumption.

\paragraph{Pull protocols} nodes that miss messages ask other nodes
for the missing messages. As a consequence, \textit{pull protocols}
more efficiently reach the last nodes of the network, as inherently,
they get messages with higher probability. However, they require
sending more messages over the network: (i) one to ask for a missing
message, and (ii) another one for the reply that contains the missing
message.  Furthermore a mechanism or a rule is needed to know what are
the missing messages to pull, which explains why these protocols are
generally used in conjunction with a push phase.
%if no pull frequency adapation mechanism is implemented, \textit{pull protocols} use data even when no messages are broadcasted, to regularly query other nodes for new messages, which can be a waste of bandwidth. Contrary \david{contrary to what??}, some message delivery can be delayed when many messages are injected in the network.
%% -> it's the same problem with balls and bins

\paragraph{Push-Pull protocols} the aim is to conciliate the best from
push and pull protocols by reaching as many nodes as possible with
minimal redundancy on the push phase.  Then, nodes that have not
received a message will send pull requests to other nodes in the
network.  By ordering messages,
Interleave~\cite{sanghavi_gossiping_2007} proposes a solution to
discover the missing messages in the pull phase, but works only with a
single source.  Instead of ordering messages,
Pulp~\cite{felber_pulp:_2012} piggybacks a list of recently received
message identifiers in every sent message, allowing multiple sources.
%Furthermore, the pull frequency is adapted to the rate of the network. 
%Moreover, there are still some redundant messages in the push and the pull phase, and asking for a list of missing messages can become expensive when many messages are missing.

%\david{add a paragraph to position here your approach}

Gossip-based disseminations are characterized by the reception of many
redundant messages in the push and pull phases in order to receive
every message with high probability. By using Random Linear Network
Coding, we aim at increasing the usefulness of exchanged messages.

\paragraph{Random Linear Network Coding} 

To improve dissemination, some protocols use erasure coding
\cite{champel_fog:_2009}\cite{sanghavi_gossiping_2007} or Random
Linear Network Coding\cite{chou_practical_2003} but need\ encoding at
the source or message ordering, which limits these techniques to
single-source scenarios.  Theoretical bounds have also been studied
for multi-sender scenarios \cite{deb_algebraic_2006}
\cite{haeupler_analyzing_2011} but they do not consider generations
and suppose that messages are previously ordered.  Network Coding is
also used on wireless
networks\cite{fragouli_efficient_2008}\cite{katti_xors_2006} but with
different system models, as emitted messages can be received by every
node within range.

Applying RLNC gossip in a multi-sender scenario implies determining to
which generation a message will belong without additional
coordination, and finding a way to link network-coding coefficients to
their respective original messages inside a generation.
